/***************************************************
 * CS182, Assignment 6: Model Merging
 * ModelMerge.java
 * Author: J.G. Makin
 * Adapted by Leon Barrett
 * Last updated: 4/02/07
 **************************************************/

/** Class ModelMerge implements the actual model merging algorithm
  use this to implement the algorithm as indicated in the hand-out.
  
  This class also houses the "main" method with which one should
  be able to test your program with.
*/

class ModelMerge{
    Grammar g;
    double alpha;
    
    /** the constructor*/
    ModelMerge(String datafile, double alpha){
    	// TODO: prepare a grammar
    }

    /** Run the model merge algorithm, calling the appropriate methods in
     * Grammar.java. */
    void run(){
    	// TODO: merge until done
    }

    // the calling convention for this program is
    //arg 0: filename of data file
    //arg 1: alpha for the cost function

    //example call to the program
    //java ModelMerge <filename> printYes <alpha>
    public static void main(String[] args){
        String datafile = null;
        double alpha = 1;

        // parse args
        try {
            // right # args
            if (args.length!=2)
                argFail();
            // datafile
            datafile = args[0];
            // alpha
            alpha = Double.parseDouble(args[1]);
        } catch (Exception e) {
            argFail();
        }

        ModelMerge mm = new ModelMerge(datafile, alpha);
        mm.run();
    }

    /** Print an argument error message and exit. */
    public static void argFail() {
        System.err.println("usage: java ModelMerge <filename> <alpha>");
        System.exit(2);
    }
}

    
